import time
from influxdb import InfluxDBClient
import sys
import csv
import numpy as np
import pandas as pd
import datetime
from sklearn.model_selection import train_test_split
from sklearn import metrics
from sklearn import tree
import matplotlib.pyplot as plt


def stringdate_to_datetime(stringdatetime: str):
    if "." in stringdatetime:
        stringdatetime = stringdatetime.split(".")[0]
    else:
        stringdatetime = stringdatetime.split("Z")[0]
    return datetime.datetime.fromtimestamp(time.mktime(time.strptime(stringdatetime, '%Y-%m-%dT%H:%M:%S')))


# for dt in data_datetimes :
#     hours.append(dt.hour)
# data['hour'] = hours

data = pd.read_csv('/Users/angus/PycharmProjects/miniProject/outputCO2.csv', sep=',')
# print(data)
data["datetime"] = data["time"].apply(stringdate_to_datetime)
# print(data)
data.set_index('datetime', inplace=True)
print("isnull", data.isnull().any())
# data.ffill()
newData = data.resample('30T').sum()
print('date', newData)

################
data1 = pd.read_csv('/Users/angus/PycharmProjects/miniProject/outputHumidity.csv', sep=',')
data1["datetime"] = data1["time"].apply(stringdate_to_datetime)
data1.set_index('datetime', inplace=True)
print("isnull", data.isnull().any())
data.ffill()
newData1 = data1.resample('30T').sum()
print('data1', newData1)

data2 = pd.read_csv('/Users/angus/PycharmProjects/miniProject/outputLumiere.csv', sep=',')
data2["datetime"] = data2["time"].apply(stringdate_to_datetime)
data2.set_index('datetime', inplace=True)
print("isnull", data.isnull().any())
data.ffill()
newData2 = data2.resample('30T').sum()
print('data2', newData2)

data3 = pd.read_csv('/Users/angus/PycharmProjects/miniProject/outputTemperature.csv', sep=',')
data3["datetime"] = data3["time"].apply(stringdate_to_datetime)
data3.set_index('datetime', inplace=True)
print("isnull", data.isnull().any())
data.ffill()
newData3 = data3.resample('30T').sum()
print('data3', newData3)

##################
# TV_POWER
##################
data4 = pd.read_csv('/Users/angus/PycharmProjects/miniProject/outputTV_POWER.csv', sep=',')
data4["datetime"] = data4["time"].apply(stringdate_to_datetime)
data4.set_index('datetime', inplace=True)
print("isnull", data.isnull().any())
data.ffill()
newData4 = data4.resample('30T').sum()
print('data4', newData4)

#########################
# wINDOW#
###########################

data5 = pd.read_csv('/Users/angus/PycharmProjects/miniProject/outputWindow.csv', sep=',')
data5["datetime"] = data5["time"].apply(stringdate_to_datetime)
data5.set_index('datetime', inplace=True)
print("isnull", data.isnull().any())
data.ffill()
newData5 = data5.resample('30T').sum()
print('data5', newData5)

##########################"
# BRUIT#
##########################

data6 = pd.read_csv('/Users/angus/PycharmProjects/miniProject/outputBruit.csv', sep=',')
data6["datetime"] = data6["time"].apply(stringdate_to_datetime)
data6.set_index('datetime', inplace=True)
print("isnull", data.isnull().any())
data.ffill()
newData6 = data6.resample('30T').sum()
print('data6', newData6)

data7 = pd.read_csv('/Users/angus/PycharmProjects/miniProject/outputheater.csv', sep=',')
data7["datetime"] = data7["time"].apply(stringdate_to_datetime)
data7.set_index('datetime', inplace=True)
print("isnull", data.isnull().any())
data.ffill()
newData7 = data7.resample('30T').sum()
print('data7', newData7)

mergeData = [newData, newData1, newData2, newData3, newData4, newData5, newData6]
result = pd.concat(mergeData, axis=1, join='inner')
print(result)

# data.set_index('datetime', inplace=True)

hours = []
data_datetimes = pd.to_datetime(data.iloc[:, 0], format='%Y-%m-%dT%H:%M:%S')
for dt in data_datetimes:
    hours.append(dt.hour)
data['hour'] = hours
print(hours)
liste = []
for ell in hours:
    if ell >= 17:
        liste.append(1)
    else:
        liste.append(0)
print(liste)

window = newData5["Window"]
CO2 = newData["CO2"]
heater = newData7["heater"]
Bruit = newData6["Bruit"]
Lumiere = newData2["Lumiere"]
for i in range(len(result)):
    if window[i] > 0 and CO2[i] < 3000:
        print("pertes d'énergie a :", hours[i], "h")
    else:
        print("Pas de pertes")
