from http.server import BaseHTTPRequestHandler, HTTPServer
import urllib
import time
from influxdb import InfluxDBClient
import sys
import csv
import numpy as np
import pandas as pd
import datetime

def stringdate_to_datetime(stringdatetime: str) :
    if "." in stringdatetime :
        stringdatetime = stringdatetime.split(".")[0]
    else :
        stringdatetime = stringdatetime.split("Z")[0]
    return datetime.datetime.fromtimestamp(time.mktime(time.strptime(stringdatetime, '%Y-%m-%dT%H:%M:%S')))

data = pd.read_csv('/Users/angus/PycharmProjects/miniProject/outputCO2.csv', sep=',')
data["datetime"] = data["time"].apply(stringdate_to_datetime)

data1 = pd.read_csv('/Users/angus/PycharmProjects/miniProject/outputHumidity.csv', sep=',')
data1["datetime"] = data["time"].apply(stringdate_to_datetime)

data2 = pd.read_csv('/Users/angus/PycharmProjects/miniProject/outputLumiere.csv', sep=',')
data2["datetime"] = data["time"].apply(stringdate_to_datetime)



###########################
#    SCRIPT SETTINGS
###########################
# Set the port where you want the bridge service to run
PORT_NUMBER = 1234
# InfluxDB Server parameters
INLUXDB_SERVER_IP = '82.65.155.71'
INLUXDB_SERVER_PORT = 8086
INFLUXDB_USERNAME = 'eleves'
INFLUXDB_PASSWORD = 'SmarthouseG2Elab'
INFLUXDB_DB_NAME = 'jeedom'
###########################

client = InfluxDBClient(INLUXDB_SERVER_IP, INLUXDB_SERVER_PORT, INFLUXDB_USERNAME, INFLUXDB_PASSWORD, INFLUXDB_DB_NAME,ssl=True, verify_ssl=False)

print(client.get_list_database())

client.switch_database('jeedom')

############
#   CO2
############

datasheet = client.query('SELECT "value" FROM "jeedom"."autogen"."3887" WHERE time > now() - 4d')

print(datasheet)

exported_data = list(datasheet.get_points())
header_list = list(exported_data[0].keys())

with open("outputCO2.csv", "w", newline='') as fp:
    writer = csv.writer(fp, dialect='excel')
    print(header_list[1:])
    value_header = header_list[1]
    offset = sum(c.isalpha() for c in value_header)
    print(offset)
    #header_list[1:] = sorted(header_list[1:], key=lambda x: int(x[offset:]))
    header_list[1:] = ['value']
    # print(header_list)
    writer.writerow(header_list)
    for line in exported_data:
        # print(line)
        writer.writerow([line[kn] for kn in header_list])


##################
#   TEMPERATURE
###################

datasheet = client.query('SELECT "value" FROM "jeedom"."autogen"."3889" WHERE time > now() - 4d')

print(datasheet)

exported_data = list(datasheet.get_points())
header_list = list(exported_data[0].keys())

with open("outputTemperature.csv", "w", newline='') as fp:
    writer = csv.writer(fp, dialect='excel')
    print(header_list[1:])
    value_header = header_list[1]
    offset = sum(c.isalpha() for c in value_header)
    print(offset)
    #header_list[1:] = sorted(header_list[1:], key=lambda x: int(x[offset:]))
    header_list[1:] = ['value']
    # print(header_list)
    writer.writerow(header_list)
    for line in exported_data:
        # print(line)
        writer.writerow([line[kn] for kn in header_list])

##############
#   HUMIDITY
##############

datasheet = client.query('SELECT "value" FROM "jeedom"."autogen"."3892" WHERE time > now() - 4d')

print(datasheet)

exported_data = list(datasheet.get_points())
header_list = list(exported_data[0].keys())

with open("outputHumidity.csv", "w", newline='') as fp:
    writer = csv.writer(fp, dialect='excel')
    print(header_list[1:])
    value_header = header_list[1]
    offset = sum(c.isalpha() for c in value_header)
    print(offset)
    #header_list[1:] = sorted(header_list[1:], key=lambda x: int(x[offset:]))
    header_list[1:] = ['value']
    # print(header_list)
    writer.writerow(header_list)
    for line in exported_data:
        # print(line)
        writer.writerow([line[kn] for kn in header_list])

###############
#   LUMIERE
###############

datasheet = client.query('SELECT "value" FROM "jeedom"."autogen"."516" WHERE time > now() - 4d')

print(datasheet)

exported_data = list(datasheet.get_points())
header_list = list(exported_data[0].keys())

with open("outputLumiere.csv", "w", newline='') as fp:
    writer = csv.writer(fp, dialect='excel')
    print(header_list[1:])
    value_header = header_list[1]
    offset = sum(c.isalpha() for c in value_header)
    print(offset)
    #header_list[1:] = sorted(header_list[1:], key=lambda x: int(x[offset:]))
    header_list[1:] = ['value']
    # print(header_list)
    writer.writerow(header_list)
    for line in exported_data:
        # print(line)
        writer.writerow([line[kn] for kn in header_list])

##############
#   TV POWER
#############
    datasheet = client.query('SELECT "value" FROM "jeedom"."autogen"."1372" WHERE time > now() - 4d')

    print(datasheet)

    exported_data = list(datasheet.get_points())
    header_list = list(exported_data[0].keys())

    with open("outputTV_POWER.csv", "w", newline='') as fp:
        writer = csv.writer(fp, dialect='excel')
        print(header_list[1:])
        value_header = header_list[1]
        offset = sum(c.isalpha() for c in value_header)
        print(offset)
        # header_list[1:] = sorted(header_list[1:], key=lambda x: int(x[offset:]))
        header_list[1:] = ['value']
        # print(header_list)
        writer.writerow(header_list)
        for line in exported_data:
            # print(line)
            writer.writerow([line[kn] for kn in header_list])

############
#   Window
############

datasheet = client.query('SELECT "value" FROM "jeedom"."autogen"."885" WHERE time > now() - 4d')

print(datasheet)

exported_data = list(datasheet.get_points())
header_list = list(exported_data[0].keys())

with open("outputWindow.csv", "w", newline='') as fp:
    writer = csv.writer(fp, dialect='excel')
    print(header_list[1:])
    value_header = header_list[1]
    offset = sum(c.isalpha() for c in value_header)
    print(offset)
    #header_list[1:] = sorted(header_list[1:], key=lambda x: int(x[offset:]))
    header_list[1:] = ['value']
    # print(header_list)
    writer.writerow(header_list)
    for line in exported_data:
        # print(line)
        writer.writerow([line[kn] for kn in header_list])

###########
#   Bruit
###########
datasheet = client.query('SELECT "value" FROM "jeedom"."autogen"."3888" WHERE time > now() - 4d')

print(datasheet)

exported_data = list(datasheet.get_points())
header_list = list(exported_data[0].keys())

with open("outputBruit.csv", "w", newline='') as fp:
    writer = csv.writer(fp, dialect='excel')
    print(header_list[1:])
    value_header = header_list[1]
    offset = sum(c.isalpha() for c in value_header)
    print(offset)
    #header_list[1:] = sorted(header_list[1:], key=lambda x: int(x[offset:]))
    header_list[1:] = ['value']
    # print(header_list)
    writer.writerow(header_list)
    for line in exported_data:
        # print(line)
        writer.writerow([line[kn] for kn in header_list])


###################
    #heater
###################

# datasheet = client.query('SELECT "value" FROM "jeedom"."autogen"."2022" WHERE time > now() - 4d')
#
# print(datasheet)
#
# exported_data = list(datasheet.get_points())
# header_list = list(exported_data[0].keys())
#
# with open("outputheater.csv", "w", newline='') as fp:
#     writer = csv.writer(fp, dialect='excel')
#     print(header_list[1:])
#     value_header = header_list[1]
#     offset = sum(c.isalpha() for c in value_header)
#     print(offset)
#     #header_list[1:] = sorted(header_list[1:], key=lambda x: int(x[offset:]))
#     header_list[1:] = ['value']
#     # print(header_list)
#     writer.writerow(header_list)
#     for line in exported_data:
#         # print(line)
#         writer.writerow([line[kn] for kn in header_list])
